resource "aws_cloudwatch_dashboard" "main" {
  dashboard_name = "${local.prefix}-main"
  dashboard_body = templatefile("${path.module}/templates/dashboards/dashboard.json.tpl",
    {
      lambda_names        = values(aws_lambda_function.crud)[*].function_name
      dynamodb_table_name = aws_dynamodb_table.main.name
      apigw_stage_name    = aws_api_gateway_stage.main.stage_name
      apigw_name          = aws_api_gateway_rest_api.main.name
      aws_region          = var.aws_region
  })
}

output "dashboard_json" {
  value = aws_cloudwatch_dashboard.main.dashboard_body
}